{% load applications_tags static %}

<div class="language-mapper autosaving" id="{{ widget.attrs.id }}__wrapper">
  <div class="language-mapper--select">
    <select name="{{ widget.name }}__choices" required id="{{ widget.id_for_label }}" multiple>
      {% for code, name, is_selected in available_languages %}
        <option value="{{ code }}"{% if is_selected %} selected{% endif %}>{{ name }}</option>
      {% endfor %}
    </select>
    <img class="autosave-indicator autosave-indicator-saving" alt="saving..." src="{% static "volunteers/autosave-spinner.svg" %}">
    <img class="autosave-indicator autosave-indicator-saved" alt="saved" src="{% static "vendor/material-icons/check.svg" %}">
    <img class="autosave-indicator autosave-indicator-error" alt="not saved because an error occured" src="{% static "vendor/material-icons/sync_problem_black_24dp.svg" %}">
  </div>
  <div class="language-mapper--levels">
  </div>
</div>
<template id="language-mapper--template">
  <div class="language-mapper-level">
    <label class="language"></label>
    <select required>
      <option disabled selected value="">--</option>
      <option value=0>Basic (A1-A2)</option>
      <option value=1>Good (B1-B2)</option>
      <option value=2>Fluent (C1-C2)</option>
      <option value=3>Native Speaker</option>
    </select>
  </div>
</template>
{{ widget.name|json_script:"language-mapper--name"}}
{{ widget.value|json_script:"language-mapper--value"}}
<script>
window.addEventListener('load', event => {
    const wrapper = document.getElementById("{{ widget.attrs.id }}__wrapper")
    const languageNames = Object.fromEntries(
        Array.from(
            wrapper.querySelectorAll('option')
        ).map(option => [option.value, option.label])
    )
    const indicators = {
        "saving": wrapper.querySelector(".autosave-indicator-saving"),
        "saved": wrapper.querySelector(".autosave-indicator-saved"),
        "error": wrapper.querySelector(".autosave-indicator-error"),
    }

    const resetIndicators = () => Object.values(indicators).forEach((i) => {i.style.opacity = 0})

    const select = wrapper.querySelector('select')
    const name = JSON.parse(document.getElementById('language-mapper--name').textContent)
    const value = JSON.parse(document.getElementById('language-mapper--value').textContent)

    const levelsContainer = wrapper.querySelector('.language-mapper--levels')
    const levelTemplate = document.getElementById("language-mapper--template")

    function reportSuccess() {
        resetIndicators()
        indicators['saved'].style.opacity = 1;
        setTimeout(() => {indicators['saved'].style.opacity = 0;}, 3000)
    }

    async function reportErrorsFromResponse(response) {
        resetIndicators()

        console.log("language mapper error", response);

        // If it's a user error
        // 1. set .field => .errors
        const field = wrapper.closest('.field')
        field.classList.add("errors")
        // 2. create error list.
        const errorlist = field.querySelector('.errorlist') || (() => {
          const el = document.createElement("ul")
          el.classList.add("errorlist")
          field.appendChild(el)
          return el
        })()
        errorlist.innerHTML = "";
        for (const msg of (await response.json()).errors.languages) {
          const li = document.createElement("li")
          li.innerText = msg
          errorlist.appendChild(li)
        }
    }

    async function saveValue() {
        resetIndicators()
        indicators['saving'].style.opacity = 1;

        const field = wrapper.closest(".field")
        field.classList.remove("errors")
        const errorlist = field.querySelector(".errorlist")
        if (errorlist) { errorlist.remove() }

        let response = null;
        try {
          response = await fetch("autosave/", {
              method: "POST",
              headers: {
                  "X-CSRFToken": document.body.dataset.csrfToken,
                  "Content-Type": "application/json",
                  },
              body: JSON.stringify({
                  languages: value
              }),
              credentials: 'same-origin',
          });
        } catch(e) {
          console.log("language mapper error", e);
          alert("Error saving languages. Please reload the page and try again.");
        }

        if (response) {
          if (response.ok) {
            reportSuccess();
          } else if (response.status == 400) {
            resetIndicators();
            indicators['error'].style.opacity = 1;
            await reportErrorsFromResponse(response)
          } else {
            resetIndicators();
            indicators['error'].style.opacity = 1;
            console.log("language mapper error", e);
            alert("Error saving languages. Please reload the page and try again.");
          }
        }
    }

    async function addLanguage(language, points) {
        const newLevel = levelTemplate.content.cloneNode(true)
        newLevel.querySelector('div').dataset.language = language
        const label = newLevel.querySelector('label')
        const select = newLevel.querySelector('select')
        const id = `language-mapper--level--${language}`

        select.id = id
        label.setAttribute('for', id)
        label.textContent = languageNames[language]

        if (points !== null) {
          select.value = points
        }
        select.addEventListener('change', async (event) => {
            value[language] = parseInt(select.value)
            await saveValue()
        })

        levelsContainer.appendChild(newLevel)
    }

    async function removeLanguage(language) {
        delete value[language]
        await saveValue()

        levelsContainer.querySelector(`[data-language="${language}"]`).remove()
    }

    Object.entries(value).forEach(([language, points]) => addLanguage(language, points))

    select._choices = new Choices(select, {
        removeItemButton: true,
        duplicateItemsAllowed: false,
    })

    select.addEventListener("addItem", (event) => addLanguage(event.detail.value, null))
    select.addEventListener("removeItem", (event) => removeLanguage(event.detail.value))
})
</script>
